<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for BelgianBusinessDossier StructType
 * @subpackage Structs
 */
class BelgianBusinessDossier extends AbstractStructBase
{
    /**
     * The errors
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\BelgianBusinessDossierErrors
     */
    public $errors;
    /**
     * The company
     * @var \StructType\BelgianBusinessCompany
     */
    public $company;
    /**
     * The bank_accounts
     * @var \ArrayType\BelgianBusinessBankAccountArray
     */
    public $bank_accounts;
    /**
     * The annual_financial_statements
     * @var \ArrayType\BelgianBusinessAnnualFinancialStatementArray
     */
    public $annual_financial_statements;
    /**
     * The legal_representative_companies
     * @var \ArrayType\BelgianBusinessLegalRepresentativeCompanyArray
     */
    public $legal_representative_companies;
    /**
     * The legal_representatives
     * @var \ArrayType\BelgianBusinessLegalRepresentativeArray
     */
    public $legal_representatives;
    /**
     * The stakeholders
     * @var \ArrayType\BelgianBusinessStakeHolderArray
     */
    public $stakeholders;
    /**
     * Constructor method for BelgianBusinessDossier
     * @uses BelgianBusinessDossier::setErrors()
     * @uses BelgianBusinessDossier::setCompany()
     * @uses BelgianBusinessDossier::setBank_accounts()
     * @uses BelgianBusinessDossier::setAnnual_financial_statements()
     * @uses BelgianBusinessDossier::setLegal_representative_companies()
     * @uses BelgianBusinessDossier::setLegal_representatives()
     * @uses BelgianBusinessDossier::setStakeholders()
     * @param \StructType\BelgianBusinessDossierErrors $errors
     * @param \StructType\BelgianBusinessCompany $company
     * @param \ArrayType\BelgianBusinessBankAccountArray $bank_accounts
     * @param \ArrayType\BelgianBusinessAnnualFinancialStatementArray $annual_financial_statements
     * @param \ArrayType\BelgianBusinessLegalRepresentativeCompanyArray $legal_representative_companies
     * @param \ArrayType\BelgianBusinessLegalRepresentativeArray $legal_representatives
     * @param \ArrayType\BelgianBusinessStakeHolderArray $stakeholders
     */
    public function __construct(\StructType\BelgianBusinessDossierErrors $errors = null, \StructType\BelgianBusinessCompany $company = null, \ArrayType\BelgianBusinessBankAccountArray $bank_accounts = null, \ArrayType\BelgianBusinessAnnualFinancialStatementArray $annual_financial_statements = null, \ArrayType\BelgianBusinessLegalRepresentativeCompanyArray $legal_representative_companies = null, \ArrayType\BelgianBusinessLegalRepresentativeArray $legal_representatives = null, \ArrayType\BelgianBusinessStakeHolderArray $stakeholders = null)
    {
        $this
            ->setErrors($errors)
            ->setCompany($company)
            ->setBank_accounts($bank_accounts)
            ->setAnnual_financial_statements($annual_financial_statements)
            ->setLegal_representative_companies($legal_representative_companies)
            ->setLegal_representatives($legal_representatives)
            ->setStakeholders($stakeholders);
    }
    /**
     * Get errors value
     * @return \StructType\BelgianBusinessDossierErrors|null
     */
    public function getErrors()
    {
        return $this->errors;
    }
    /**
     * Set errors value
     * @param \StructType\BelgianBusinessDossierErrors $errors
     * @return \StructType\BelgianBusinessDossier
     */
    public function setErrors(\StructType\BelgianBusinessDossierErrors $errors = null)
    {
        $this->errors = $errors;
        return $this;
    }
    /**
     * Get company value
     * @return \StructType\BelgianBusinessCompany|null
     */
    public function getCompany()
    {
        return $this->company;
    }
    /**
     * Set company value
     * @param \StructType\BelgianBusinessCompany $company
     * @return \StructType\BelgianBusinessDossier
     */
    public function setCompany(\StructType\BelgianBusinessCompany $company = null)
    {
        $this->company = $company;
        return $this;
    }
    /**
     * Get bank_accounts value
     * @return \ArrayType\BelgianBusinessBankAccountArray|null
     */
    public function getBank_accounts()
    {
        return $this->bank_accounts;
    }
    /**
     * Set bank_accounts value
     * @param \ArrayType\BelgianBusinessBankAccountArray $bank_accounts
     * @return \StructType\BelgianBusinessDossier
     */
    public function setBank_accounts(\ArrayType\BelgianBusinessBankAccountArray $bank_accounts = null)
    {
        $this->bank_accounts = $bank_accounts;
        return $this;
    }
    /**
     * Get annual_financial_statements value
     * @return \ArrayType\BelgianBusinessAnnualFinancialStatementArray|null
     */
    public function getAnnual_financial_statements()
    {
        return $this->annual_financial_statements;
    }
    /**
     * Set annual_financial_statements value
     * @param \ArrayType\BelgianBusinessAnnualFinancialStatementArray $annual_financial_statements
     * @return \StructType\BelgianBusinessDossier
     */
    public function setAnnual_financial_statements(\ArrayType\BelgianBusinessAnnualFinancialStatementArray $annual_financial_statements = null)
    {
        $this->annual_financial_statements = $annual_financial_statements;
        return $this;
    }
    /**
     * Get legal_representative_companies value
     * @return \ArrayType\BelgianBusinessLegalRepresentativeCompanyArray|null
     */
    public function getLegal_representative_companies()
    {
        return $this->legal_representative_companies;
    }
    /**
     * Set legal_representative_companies value
     * @param \ArrayType\BelgianBusinessLegalRepresentativeCompanyArray $legal_representative_companies
     * @return \StructType\BelgianBusinessDossier
     */
    public function setLegal_representative_companies(\ArrayType\BelgianBusinessLegalRepresentativeCompanyArray $legal_representative_companies = null)
    {
        $this->legal_representative_companies = $legal_representative_companies;
        return $this;
    }
    /**
     * Get legal_representatives value
     * @return \ArrayType\BelgianBusinessLegalRepresentativeArray|null
     */
    public function getLegal_representatives()
    {
        return $this->legal_representatives;
    }
    /**
     * Set legal_representatives value
     * @param \ArrayType\BelgianBusinessLegalRepresentativeArray $legal_representatives
     * @return \StructType\BelgianBusinessDossier
     */
    public function setLegal_representatives(\ArrayType\BelgianBusinessLegalRepresentativeArray $legal_representatives = null)
    {
        $this->legal_representatives = $legal_representatives;
        return $this;
    }
    /**
     * Get stakeholders value
     * @return \ArrayType\BelgianBusinessStakeHolderArray|null
     */
    public function getStakeholders()
    {
        return $this->stakeholders;
    }
    /**
     * Set stakeholders value
     * @param \ArrayType\BelgianBusinessStakeHolderArray $stakeholders
     * @return \StructType\BelgianBusinessDossier
     */
    public function setStakeholders(\ArrayType\BelgianBusinessStakeHolderArray $stakeholders = null)
    {
        $this->stakeholders = $stakeholders;
        return $this;
    }
}
