<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CarATDPrices StructType
 * @subpackage Structs
 */
class CarATDPrices extends AbstractStructBase
{
    /**
     * The brand
     * @var string
     */
    public $brand;
    /**
     * The model
     * @var string
     */
    public $model;
    /**
     * The type
     * @var string
     */
    public $type;
    /**
     * The valuations
     * @var \ArrayType\CarATDValuationArray
     */
    public $valuations;
    /**
     * Constructor method for CarATDPrices
     * @uses CarATDPrices::setBrand()
     * @uses CarATDPrices::setModel()
     * @uses CarATDPrices::setType()
     * @uses CarATDPrices::setValuations()
     * @param string $brand
     * @param string $model
     * @param string $type
     * @param \ArrayType\CarATDValuationArray $valuations
     */
    public function __construct($brand = null, $model = null, $type = null, \ArrayType\CarATDValuationArray $valuations = null)
    {
        $this
            ->setBrand($brand)
            ->setModel($model)
            ->setType($type)
            ->setValuations($valuations);
    }
    /**
     * Get brand value
     * @return string|null
     */
    public function getBrand()
    {
        return $this->brand;
    }
    /**
     * Set brand value
     * @param string $brand
     * @return \StructType\CarATDPrices
     */
    public function setBrand($brand = null)
    {
        // validation for constraint: string
        if (!is_null($brand) && !is_string($brand)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($brand, true), gettype($brand)), __LINE__);
        }
        $this->brand = $brand;
        return $this;
    }
    /**
     * Get model value
     * @return string|null
     */
    public function getModel()
    {
        return $this->model;
    }
    /**
     * Set model value
     * @param string $model
     * @return \StructType\CarATDPrices
     */
    public function setModel($model = null)
    {
        // validation for constraint: string
        if (!is_null($model) && !is_string($model)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($model, true), gettype($model)), __LINE__);
        }
        $this->model = $model;
        return $this;
    }
    /**
     * Get type value
     * @return string|null
     */
    public function getType()
    {
        return $this->type;
    }
    /**
     * Set type value
     * @param string $type
     * @return \StructType\CarATDPrices
     */
    public function setType($type = null)
    {
        // validation for constraint: string
        if (!is_null($type) && !is_string($type)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($type, true), gettype($type)), __LINE__);
        }
        $this->type = $type;
        return $this;
    }
    /**
     * Get valuations value
     * @return \ArrayType\CarATDValuationArray|null
     */
    public function getValuations()
    {
        return $this->valuations;
    }
    /**
     * Set valuations value
     * @param \ArrayType\CarATDValuationArray $valuations
     * @return \StructType\CarATDPrices
     */
    public function setValuations(\ArrayType\CarATDValuationArray $valuations = null)
    {
        $this->valuations = $valuations;
        return $this;
    }
}
