<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CreditsafeAddressV2 StructType
 * @subpackage Structs
 */
class CreditsafeAddressV2 extends AbstractStructBase
{
    /**
     * The city
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $city;
    /**
     * The country
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $country;
    /**
     * The full_address
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $full_address;
    /**
     * The house_number
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $house_number;
    /**
     * The postal_code
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $postal_code;
    /**
     * The street
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $street;
    /**
     * The telephone
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $telephone;
    /**
     * Constructor method for CreditsafeAddressV2
     * @uses CreditsafeAddressV2::setCity()
     * @uses CreditsafeAddressV2::setCountry()
     * @uses CreditsafeAddressV2::setFull_address()
     * @uses CreditsafeAddressV2::setHouse_number()
     * @uses CreditsafeAddressV2::setPostal_code()
     * @uses CreditsafeAddressV2::setStreet()
     * @uses CreditsafeAddressV2::setTelephone()
     * @param string $city
     * @param string $country
     * @param string $full_address
     * @param string $house_number
     * @param string $postal_code
     * @param string $street
     * @param string $telephone
     */
    public function __construct($city = null, $country = null, $full_address = null, $house_number = null, $postal_code = null, $street = null, $telephone = null)
    {
        $this
            ->setCity($city)
            ->setCountry($country)
            ->setFull_address($full_address)
            ->setHouse_number($house_number)
            ->setPostal_code($postal_code)
            ->setStreet($street)
            ->setTelephone($telephone);
    }
    /**
     * Get city value
     * @return string|null
     */
    public function getCity()
    {
        return $this->city;
    }
    /**
     * Set city value
     * @param string $city
     * @return \StructType\CreditsafeAddressV2
     */
    public function setCity($city = null)
    {
        // validation for constraint: string
        if (!is_null($city) && !is_string($city)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($city, true), gettype($city)), __LINE__);
        }
        $this->city = $city;
        return $this;
    }
    /**
     * Get country value
     * @return string|null
     */
    public function getCountry()
    {
        return $this->country;
    }
    /**
     * Set country value
     * @param string $country
     * @return \StructType\CreditsafeAddressV2
     */
    public function setCountry($country = null)
    {
        // validation for constraint: string
        if (!is_null($country) && !is_string($country)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($country, true), gettype($country)), __LINE__);
        }
        $this->country = $country;
        return $this;
    }
    /**
     * Get full_address value
     * @return string|null
     */
    public function getFull_address()
    {
        return $this->full_address;
    }
    /**
     * Set full_address value
     * @param string $full_address
     * @return \StructType\CreditsafeAddressV2
     */
    public function setFull_address($full_address = null)
    {
        // validation for constraint: string
        if (!is_null($full_address) && !is_string($full_address)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($full_address, true), gettype($full_address)), __LINE__);
        }
        $this->full_address = $full_address;
        return $this;
    }
    /**
     * Get house_number value
     * @return string|null
     */
    public function getHouse_number()
    {
        return $this->house_number;
    }
    /**
     * Set house_number value
     * @param string $house_number
     * @return \StructType\CreditsafeAddressV2
     */
    public function setHouse_number($house_number = null)
    {
        // validation for constraint: string
        if (!is_null($house_number) && !is_string($house_number)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($house_number, true), gettype($house_number)), __LINE__);
        }
        $this->house_number = $house_number;
        return $this;
    }
    /**
     * Get postal_code value
     * @return string|null
     */
    public function getPostal_code()
    {
        return $this->postal_code;
    }
    /**
     * Set postal_code value
     * @param string $postal_code
     * @return \StructType\CreditsafeAddressV2
     */
    public function setPostal_code($postal_code = null)
    {
        // validation for constraint: string
        if (!is_null($postal_code) && !is_string($postal_code)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($postal_code, true), gettype($postal_code)), __LINE__);
        }
        $this->postal_code = $postal_code;
        return $this;
    }
    /**
     * Get street value
     * @return string|null
     */
    public function getStreet()
    {
        return $this->street;
    }
    /**
     * Set street value
     * @param string $street
     * @return \StructType\CreditsafeAddressV2
     */
    public function setStreet($street = null)
    {
        // validation for constraint: string
        if (!is_null($street) && !is_string($street)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($street, true), gettype($street)), __LINE__);
        }
        $this->street = $street;
        return $this;
    }
    /**
     * Get telephone value
     * @return string|null
     */
    public function getTelephone()
    {
        return $this->telephone;
    }
    /**
     * Set telephone value
     * @param string $telephone
     * @return \StructType\CreditsafeAddressV2
     */
    public function setTelephone($telephone = null)
    {
        // validation for constraint: string
        if (!is_null($telephone) && !is_string($telephone)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($telephone, true), gettype($telephone)), __LINE__);
        }
        $this->telephone = $telephone;
        return $this;
    }
}
