<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CreditsafeCompanyBasicInformationV2 StructType
 * @subpackage Structs
 */
class CreditsafeCompanyBasicInformationV2 extends AbstractStructBase
{
    /**
     * The company_status
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\CreditsafeCompanyStatusV2
     */
    public $company_status;
    /**
     * The contact_address
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\CreditsafeAddressV2
     */
    public $contact_address;
    /**
     * The legal_form
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\CreditsafeDescriptionV2
     */
    public $legal_form;
    /**
     * The principal_activity
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\CreditsafeDescriptionV2
     */
    public $principal_activity;
    /**
     * The business_name
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $business_name;
    /**
     * The company_registration_number
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $company_registration_number;
    /**
     * The country
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $country;
    /**
     * The dateof_company_registration
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $dateof_company_registration;
    /**
     * The dateof_starting_operations
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $dateof_starting_operations;
    /**
     * The registered_company_name
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $registered_company_name;
    /**
     * The vat_registration_number
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $vat_registration_number;
    /**
     * Constructor method for CreditsafeCompanyBasicInformationV2
     * @uses CreditsafeCompanyBasicInformationV2::setCompany_status()
     * @uses CreditsafeCompanyBasicInformationV2::setContact_address()
     * @uses CreditsafeCompanyBasicInformationV2::setLegal_form()
     * @uses CreditsafeCompanyBasicInformationV2::setPrincipal_activity()
     * @uses CreditsafeCompanyBasicInformationV2::setBusiness_name()
     * @uses CreditsafeCompanyBasicInformationV2::setCompany_registration_number()
     * @uses CreditsafeCompanyBasicInformationV2::setCountry()
     * @uses CreditsafeCompanyBasicInformationV2::setDateof_company_registration()
     * @uses CreditsafeCompanyBasicInformationV2::setDateof_starting_operations()
     * @uses CreditsafeCompanyBasicInformationV2::setRegistered_company_name()
     * @uses CreditsafeCompanyBasicInformationV2::setVat_registration_number()
     * @param \StructType\CreditsafeCompanyStatusV2 $company_status
     * @param \StructType\CreditsafeAddressV2 $contact_address
     * @param \StructType\CreditsafeDescriptionV2 $legal_form
     * @param \StructType\CreditsafeDescriptionV2 $principal_activity
     * @param string $business_name
     * @param string $company_registration_number
     * @param string $country
     * @param string $dateof_company_registration
     * @param string $dateof_starting_operations
     * @param string $registered_company_name
     * @param string $vat_registration_number
     */
    public function __construct(\StructType\CreditsafeCompanyStatusV2 $company_status = null, \StructType\CreditsafeAddressV2 $contact_address = null, \StructType\CreditsafeDescriptionV2 $legal_form = null, \StructType\CreditsafeDescriptionV2 $principal_activity = null, $business_name = null, $company_registration_number = null, $country = null, $dateof_company_registration = null, $dateof_starting_operations = null, $registered_company_name = null, $vat_registration_number = null)
    {
        $this
            ->setCompany_status($company_status)
            ->setContact_address($contact_address)
            ->setLegal_form($legal_form)
            ->setPrincipal_activity($principal_activity)
            ->setBusiness_name($business_name)
            ->setCompany_registration_number($company_registration_number)
            ->setCountry($country)
            ->setDateof_company_registration($dateof_company_registration)
            ->setDateof_starting_operations($dateof_starting_operations)
            ->setRegistered_company_name($registered_company_name)
            ->setVat_registration_number($vat_registration_number);
    }
    /**
     * Get company_status value
     * @return \StructType\CreditsafeCompanyStatusV2|null
     */
    public function getCompany_status()
    {
        return $this->company_status;
    }
    /**
     * Set company_status value
     * @param \StructType\CreditsafeCompanyStatusV2 $company_status
     * @return \StructType\CreditsafeCompanyBasicInformationV2
     */
    public function setCompany_status(\StructType\CreditsafeCompanyStatusV2 $company_status = null)
    {
        $this->company_status = $company_status;
        return $this;
    }
    /**
     * Get contact_address value
     * @return \StructType\CreditsafeAddressV2|null
     */
    public function getContact_address()
    {
        return $this->contact_address;
    }
    /**
     * Set contact_address value
     * @param \StructType\CreditsafeAddressV2 $contact_address
     * @return \StructType\CreditsafeCompanyBasicInformationV2
     */
    public function setContact_address(\StructType\CreditsafeAddressV2 $contact_address = null)
    {
        $this->contact_address = $contact_address;
        return $this;
    }
    /**
     * Get legal_form value
     * @return \StructType\CreditsafeDescriptionV2|null
     */
    public function getLegal_form()
    {
        return $this->legal_form;
    }
    /**
     * Set legal_form value
     * @param \StructType\CreditsafeDescriptionV2 $legal_form
     * @return \StructType\CreditsafeCompanyBasicInformationV2
     */
    public function setLegal_form(\StructType\CreditsafeDescriptionV2 $legal_form = null)
    {
        $this->legal_form = $legal_form;
        return $this;
    }
    /**
     * Get principal_activity value
     * @return \StructType\CreditsafeDescriptionV2|null
     */
    public function getPrincipal_activity()
    {
        return $this->principal_activity;
    }
    /**
     * Set principal_activity value
     * @param \StructType\CreditsafeDescriptionV2 $principal_activity
     * @return \StructType\CreditsafeCompanyBasicInformationV2
     */
    public function setPrincipal_activity(\StructType\CreditsafeDescriptionV2 $principal_activity = null)
    {
        $this->principal_activity = $principal_activity;
        return $this;
    }
    /**
     * Get business_name value
     * @return string|null
     */
    public function getBusiness_name()
    {
        return $this->business_name;
    }
    /**
     * Set business_name value
     * @param string $business_name
     * @return \StructType\CreditsafeCompanyBasicInformationV2
     */
    public function setBusiness_name($business_name = null)
    {
        // validation for constraint: string
        if (!is_null($business_name) && !is_string($business_name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($business_name, true), gettype($business_name)), __LINE__);
        }
        $this->business_name = $business_name;
        return $this;
    }
    /**
     * Get company_registration_number value
     * @return string|null
     */
    public function getCompany_registration_number()
    {
        return $this->company_registration_number;
    }
    /**
     * Set company_registration_number value
     * @param string $company_registration_number
     * @return \StructType\CreditsafeCompanyBasicInformationV2
     */
    public function setCompany_registration_number($company_registration_number = null)
    {
        // validation for constraint: string
        if (!is_null($company_registration_number) && !is_string($company_registration_number)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($company_registration_number, true), gettype($company_registration_number)), __LINE__);
        }
        $this->company_registration_number = $company_registration_number;
        return $this;
    }
    /**
     * Get country value
     * @return string|null
     */
    public function getCountry()
    {
        return $this->country;
    }
    /**
     * Set country value
     * @param string $country
     * @return \StructType\CreditsafeCompanyBasicInformationV2
     */
    public function setCountry($country = null)
    {
        // validation for constraint: string
        if (!is_null($country) && !is_string($country)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($country, true), gettype($country)), __LINE__);
        }
        $this->country = $country;
        return $this;
    }
    /**
     * Get dateof_company_registration value
     * @return string|null
     */
    public function getDateof_company_registration()
    {
        return $this->dateof_company_registration;
    }
    /**
     * Set dateof_company_registration value
     * @param string $dateof_company_registration
     * @return \StructType\CreditsafeCompanyBasicInformationV2
     */
    public function setDateof_company_registration($dateof_company_registration = null)
    {
        // validation for constraint: string
        if (!is_null($dateof_company_registration) && !is_string($dateof_company_registration)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($dateof_company_registration, true), gettype($dateof_company_registration)), __LINE__);
        }
        $this->dateof_company_registration = $dateof_company_registration;
        return $this;
    }
    /**
     * Get dateof_starting_operations value
     * @return string|null
     */
    public function getDateof_starting_operations()
    {
        return $this->dateof_starting_operations;
    }
    /**
     * Set dateof_starting_operations value
     * @param string $dateof_starting_operations
     * @return \StructType\CreditsafeCompanyBasicInformationV2
     */
    public function setDateof_starting_operations($dateof_starting_operations = null)
    {
        // validation for constraint: string
        if (!is_null($dateof_starting_operations) && !is_string($dateof_starting_operations)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($dateof_starting_operations, true), gettype($dateof_starting_operations)), __LINE__);
        }
        $this->dateof_starting_operations = $dateof_starting_operations;
        return $this;
    }
    /**
     * Get registered_company_name value
     * @return string|null
     */
    public function getRegistered_company_name()
    {
        return $this->registered_company_name;
    }
    /**
     * Set registered_company_name value
     * @param string $registered_company_name
     * @return \StructType\CreditsafeCompanyBasicInformationV2
     */
    public function setRegistered_company_name($registered_company_name = null)
    {
        // validation for constraint: string
        if (!is_null($registered_company_name) && !is_string($registered_company_name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($registered_company_name, true), gettype($registered_company_name)), __LINE__);
        }
        $this->registered_company_name = $registered_company_name;
        return $this;
    }
    /**
     * Get vat_registration_number value
     * @return string|null
     */
    public function getVat_registration_number()
    {
        return $this->vat_registration_number;
    }
    /**
     * Set vat_registration_number value
     * @param string $vat_registration_number
     * @return \StructType\CreditsafeCompanyBasicInformationV2
     */
    public function setVat_registration_number($vat_registration_number = null)
    {
        // validation for constraint: string
        if (!is_null($vat_registration_number) && !is_string($vat_registration_number)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($vat_registration_number, true), gettype($vat_registration_number)), __LINE__);
        }
        $this->vat_registration_number = $vat_registration_number;
        return $this;
    }
}
