<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CreditsafeCompanyV2 StructType
 * @subpackage Structs
 */
class CreditsafeCompanyV2 extends AbstractStructBase
{
    /**
     * The address
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\CreditsafeAddressV2
     */
    public $address;
    /**
     * The creditsafe_number
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $creditsafe_number;
    /**
     * The date_last_account
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $date_last_account;
    /**
     * The date_last_change
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $date_last_change;
    /**
     * The trade_names
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \ArrayType\StringArray
     */
    public $trade_names;
    /**
     * The vat_numbers
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \ArrayType\StringArray
     */
    public $vat_numbers;
    /**
     * The country
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $country;
    /**
     * The registration_number
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $registration_number;
    /**
     * The name
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $name;
    /**
     * The id
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $id;
    /**
     * The type
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $type;
    /**
     * The status
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $status;
    /**
     * The office_type
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $office_type;
    /**
     * Constructor method for CreditsafeCompanyV2
     * @uses CreditsafeCompanyV2::setAddress()
     * @uses CreditsafeCompanyV2::setCreditsafe_number()
     * @uses CreditsafeCompanyV2::setDate_last_account()
     * @uses CreditsafeCompanyV2::setDate_last_change()
     * @uses CreditsafeCompanyV2::setTrade_names()
     * @uses CreditsafeCompanyV2::setVat_numbers()
     * @uses CreditsafeCompanyV2::setCountry()
     * @uses CreditsafeCompanyV2::setRegistration_number()
     * @uses CreditsafeCompanyV2::setName()
     * @uses CreditsafeCompanyV2::setId()
     * @uses CreditsafeCompanyV2::setType()
     * @uses CreditsafeCompanyV2::setStatus()
     * @uses CreditsafeCompanyV2::setOffice_type()
     * @param \StructType\CreditsafeAddressV2 $address
     * @param string $creditsafe_number
     * @param string $date_last_account
     * @param string $date_last_change
     * @param \ArrayType\StringArray $trade_names
     * @param \ArrayType\StringArray $vat_numbers
     * @param string $country
     * @param string $registration_number
     * @param string $name
     * @param string $id
     * @param string $type
     * @param string $status
     * @param string $office_type
     */
    public function __construct(\StructType\CreditsafeAddressV2 $address = null, $creditsafe_number = null, $date_last_account = null, $date_last_change = null, \ArrayType\StringArray $trade_names = null, \ArrayType\StringArray $vat_numbers = null, $country = null, $registration_number = null, $name = null, $id = null, $type = null, $status = null, $office_type = null)
    {
        $this
            ->setAddress($address)
            ->setCreditsafe_number($creditsafe_number)
            ->setDate_last_account($date_last_account)
            ->setDate_last_change($date_last_change)
            ->setTrade_names($trade_names)
            ->setVat_numbers($vat_numbers)
            ->setCountry($country)
            ->setRegistration_number($registration_number)
            ->setName($name)
            ->setId($id)
            ->setType($type)
            ->setStatus($status)
            ->setOffice_type($office_type);
    }
    /**
     * Get address value
     * @return \StructType\CreditsafeAddressV2|null
     */
    public function getAddress()
    {
        return $this->address;
    }
    /**
     * Set address value
     * @param \StructType\CreditsafeAddressV2 $address
     * @return \StructType\CreditsafeCompanyV2
     */
    public function setAddress(\StructType\CreditsafeAddressV2 $address = null)
    {
        $this->address = $address;
        return $this;
    }
    /**
     * Get creditsafe_number value
     * @return string|null
     */
    public function getCreditsafe_number()
    {
        return $this->creditsafe_number;
    }
    /**
     * Set creditsafe_number value
     * @param string $creditsafe_number
     * @return \StructType\CreditsafeCompanyV2
     */
    public function setCreditsafe_number($creditsafe_number = null)
    {
        // validation for constraint: string
        if (!is_null($creditsafe_number) && !is_string($creditsafe_number)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($creditsafe_number, true), gettype($creditsafe_number)), __LINE__);
        }
        $this->creditsafe_number = $creditsafe_number;
        return $this;
    }
    /**
     * Get date_last_account value
     * @return string|null
     */
    public function getDate_last_account()
    {
        return $this->date_last_account;
    }
    /**
     * Set date_last_account value
     * @param string $date_last_account
     * @return \StructType\CreditsafeCompanyV2
     */
    public function setDate_last_account($date_last_account = null)
    {
        // validation for constraint: string
        if (!is_null($date_last_account) && !is_string($date_last_account)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($date_last_account, true), gettype($date_last_account)), __LINE__);
        }
        $this->date_last_account = $date_last_account;
        return $this;
    }
    /**
     * Get date_last_change value
     * @return string|null
     */
    public function getDate_last_change()
    {
        return $this->date_last_change;
    }
    /**
     * Set date_last_change value
     * @param string $date_last_change
     * @return \StructType\CreditsafeCompanyV2
     */
    public function setDate_last_change($date_last_change = null)
    {
        // validation for constraint: string
        if (!is_null($date_last_change) && !is_string($date_last_change)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($date_last_change, true), gettype($date_last_change)), __LINE__);
        }
        $this->date_last_change = $date_last_change;
        return $this;
    }
    /**
     * Get trade_names value
     * @return \ArrayType\StringArray|null
     */
    public function getTrade_names()
    {
        return $this->trade_names;
    }
    /**
     * Set trade_names value
     * @param \ArrayType\StringArray $trade_names
     * @return \StructType\CreditsafeCompanyV2
     */
    public function setTrade_names(\ArrayType\StringArray $trade_names = null)
    {
        $this->trade_names = $trade_names;
        return $this;
    }
    /**
     * Get vat_numbers value
     * @return \ArrayType\StringArray|null
     */
    public function getVat_numbers()
    {
        return $this->vat_numbers;
    }
    /**
     * Set vat_numbers value
     * @param \ArrayType\StringArray $vat_numbers
     * @return \StructType\CreditsafeCompanyV2
     */
    public function setVat_numbers(\ArrayType\StringArray $vat_numbers = null)
    {
        $this->vat_numbers = $vat_numbers;
        return $this;
    }
    /**
     * Get country value
     * @return string|null
     */
    public function getCountry()
    {
        return $this->country;
    }
    /**
     * Set country value
     * @param string $country
     * @return \StructType\CreditsafeCompanyV2
     */
    public function setCountry($country = null)
    {
        // validation for constraint: string
        if (!is_null($country) && !is_string($country)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($country, true), gettype($country)), __LINE__);
        }
        $this->country = $country;
        return $this;
    }
    /**
     * Get registration_number value
     * @return string|null
     */
    public function getRegistration_number()
    {
        return $this->registration_number;
    }
    /**
     * Set registration_number value
     * @param string $registration_number
     * @return \StructType\CreditsafeCompanyV2
     */
    public function setRegistration_number($registration_number = null)
    {
        // validation for constraint: string
        if (!is_null($registration_number) && !is_string($registration_number)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($registration_number, true), gettype($registration_number)), __LINE__);
        }
        $this->registration_number = $registration_number;
        return $this;
    }
    /**
     * Get name value
     * @return string|null
     */
    public function getName()
    {
        return $this->name;
    }
    /**
     * Set name value
     * @param string $name
     * @return \StructType\CreditsafeCompanyV2
     */
    public function setName($name = null)
    {
        // validation for constraint: string
        if (!is_null($name) && !is_string($name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($name, true), gettype($name)), __LINE__);
        }
        $this->name = $name;
        return $this;
    }
    /**
     * Get id value
     * @return string|null
     */
    public function getId()
    {
        return $this->id;
    }
    /**
     * Set id value
     * @param string $id
     * @return \StructType\CreditsafeCompanyV2
     */
    public function setId($id = null)
    {
        // validation for constraint: string
        if (!is_null($id) && !is_string($id)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($id, true), gettype($id)), __LINE__);
        }
        $this->id = $id;
        return $this;
    }
    /**
     * Get type value
     * @return string|null
     */
    public function getType()
    {
        return $this->type;
    }
    /**
     * Set type value
     * @param string $type
     * @return \StructType\CreditsafeCompanyV2
     */
    public function setType($type = null)
    {
        // validation for constraint: string
        if (!is_null($type) && !is_string($type)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($type, true), gettype($type)), __LINE__);
        }
        $this->type = $type;
        return $this;
    }
    /**
     * Get status value
     * @return string|null
     */
    public function getStatus()
    {
        return $this->status;
    }
    /**
     * Set status value
     * @param string $status
     * @return \StructType\CreditsafeCompanyV2
     */
    public function setStatus($status = null)
    {
        // validation for constraint: string
        if (!is_null($status) && !is_string($status)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($status, true), gettype($status)), __LINE__);
        }
        $this->status = $status;
        return $this;
    }
    /**
     * Get office_type value
     * @return string|null
     */
    public function getOffice_type()
    {
        return $this->office_type;
    }
    /**
     * Set office_type value
     * @param string $office_type
     * @return \StructType\CreditsafeCompanyV2
     */
    public function setOffice_type($office_type = null)
    {
        // validation for constraint: string
        if (!is_null($office_type) && !is_string($office_type)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($office_type, true), gettype($office_type)), __LINE__);
        }
        $this->office_type = $office_type;
        return $this;
    }
}
