<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for DNBEmployeeCount StructType
 * @subpackage Structs
 */
class DNBEmployeeCount extends AbstractStructBase
{
    /**
     * The employees
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $employees;
    /**
     * The employees_text
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $employees_text;
    /**
     * The estimated
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $estimated;
    /**
     * The subsidiaries_included
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $subsidiaries_included;
    /**
     * The qualification_indicator
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $qualification_indicator;
    /**
     * Constructor method for DNBEmployeeCount
     * @uses DNBEmployeeCount::setEmployees()
     * @uses DNBEmployeeCount::setEmployees_text()
     * @uses DNBEmployeeCount::setEstimated()
     * @uses DNBEmployeeCount::setSubsidiaries_included()
     * @uses DNBEmployeeCount::setQualification_indicator()
     * @param int $employees
     * @param string $employees_text
     * @param bool $estimated
     * @param bool $subsidiaries_included
     * @param string $qualification_indicator
     */
    public function __construct($employees = null, $employees_text = null, $estimated = null, $subsidiaries_included = null, $qualification_indicator = null)
    {
        $this
            ->setEmployees($employees)
            ->setEmployees_text($employees_text)
            ->setEstimated($estimated)
            ->setSubsidiaries_included($subsidiaries_included)
            ->setQualification_indicator($qualification_indicator);
    }
    /**
     * Get employees value
     * @return int|null
     */
    public function getEmployees()
    {
        return $this->employees;
    }
    /**
     * Set employees value
     * @param int $employees
     * @return \StructType\DNBEmployeeCount
     */
    public function setEmployees($employees = null)
    {
        // validation for constraint: int
        if (!is_null($employees) && !(is_int($employees) || ctype_digit($employees))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($employees, true), gettype($employees)), __LINE__);
        }
        $this->employees = $employees;
        return $this;
    }
    /**
     * Get employees_text value
     * @return string|null
     */
    public function getEmployees_text()
    {
        return $this->employees_text;
    }
    /**
     * Set employees_text value
     * @param string $employees_text
     * @return \StructType\DNBEmployeeCount
     */
    public function setEmployees_text($employees_text = null)
    {
        // validation for constraint: string
        if (!is_null($employees_text) && !is_string($employees_text)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($employees_text, true), gettype($employees_text)), __LINE__);
        }
        $this->employees_text = $employees_text;
        return $this;
    }
    /**
     * Get estimated value
     * @return bool|null
     */
    public function getEstimated()
    {
        return $this->estimated;
    }
    /**
     * Set estimated value
     * @param bool $estimated
     * @return \StructType\DNBEmployeeCount
     */
    public function setEstimated($estimated = null)
    {
        // validation for constraint: boolean
        if (!is_null($estimated) && !is_bool($estimated)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($estimated, true), gettype($estimated)), __LINE__);
        }
        $this->estimated = $estimated;
        return $this;
    }
    /**
     * Get subsidiaries_included value
     * @return bool|null
     */
    public function getSubsidiaries_included()
    {
        return $this->subsidiaries_included;
    }
    /**
     * Set subsidiaries_included value
     * @param bool $subsidiaries_included
     * @return \StructType\DNBEmployeeCount
     */
    public function setSubsidiaries_included($subsidiaries_included = null)
    {
        // validation for constraint: boolean
        if (!is_null($subsidiaries_included) && !is_bool($subsidiaries_included)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($subsidiaries_included, true), gettype($subsidiaries_included)), __LINE__);
        }
        $this->subsidiaries_included = $subsidiaries_included;
        return $this;
    }
    /**
     * Get qualification_indicator value
     * @return string|null
     */
    public function getQualification_indicator()
    {
        return $this->qualification_indicator;
    }
    /**
     * Set qualification_indicator value
     * @param string $qualification_indicator
     * @return \StructType\DNBEmployeeCount
     */
    public function setQualification_indicator($qualification_indicator = null)
    {
        // validation for constraint: string
        if (!is_null($qualification_indicator) && !is_string($qualification_indicator)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($qualification_indicator, true), gettype($qualification_indicator)), __LINE__);
        }
        $this->qualification_indicator = $qualification_indicator;
        return $this;
    }
}
