<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for DutchBusinessChangeSet StructType
 * @subpackage Structs
 */
class DutchBusinessChangeSet extends AbstractStructBase
{
    /**
     * The period
     * @var \StructType\DutchBusinessPeriod
     */
    public $period;
    /**
     * The changes
     * @var \ArrayType\StringArray
     */
    public $changes;
    /**
     * Constructor method for DutchBusinessChangeSet
     * @uses DutchBusinessChangeSet::setPeriod()
     * @uses DutchBusinessChangeSet::setChanges()
     * @param \StructType\DutchBusinessPeriod $period
     * @param \ArrayType\StringArray $changes
     */
    public function __construct(\StructType\DutchBusinessPeriod $period = null, \ArrayType\StringArray $changes = null)
    {
        $this
            ->setPeriod($period)
            ->setChanges($changes);
    }
    /**
     * Get period value
     * @return \StructType\DutchBusinessPeriod|null
     */
    public function getPeriod()
    {
        return $this->period;
    }
    /**
     * Set period value
     * @param \StructType\DutchBusinessPeriod $period
     * @return \StructType\DutchBusinessChangeSet
     */
    public function setPeriod(\StructType\DutchBusinessPeriod $period = null)
    {
        $this->period = $period;
        return $this;
    }
    /**
     * Get changes value
     * @return \ArrayType\StringArray|null
     */
    public function getChanges()
    {
        return $this->changes;
    }
    /**
     * Set changes value
     * @param \ArrayType\StringArray $changes
     * @return \StructType\DutchBusinessChangeSet
     */
    public function setChanges(\ArrayType\StringArray $changes = null)
    {
        $this->changes = $changes;
        return $this;
    }
}
