<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for DutchBusinessExtractDataV2 StructType
 * @subpackage Structs
 */
class DutchBusinessExtractDataV2 extends AbstractStructBase
{
    /**
     * The dossier_number
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $dossier_number;
    /**
     * The reference_date
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $reference_date;
    /**
     * The legal_entity
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\DutchBusinessLegalEntityV2
     */
    public $legal_entity;
    /**
     * The partnership
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\DutchBusinessPartnershipV2
     */
    public $partnership;
    /**
     * The enterprise
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\DutchBusinessEnterpriseV2
     */
    public $enterprise;
    /**
     * The establishments
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \ArrayType\DutchBusinessEstablishmentV2Array
     */
    public $establishments;
    /**
     * The positions
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \ArrayType\DutchBusinessPositionV2Array
     */
    public $positions;
    /**
     * The remarks
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \ArrayType\StringArray
     */
    public $remarks;
    /**
     * Constructor method for DutchBusinessExtractDataV2
     * @uses DutchBusinessExtractDataV2::setDossier_number()
     * @uses DutchBusinessExtractDataV2::setReference_date()
     * @uses DutchBusinessExtractDataV2::setLegal_entity()
     * @uses DutchBusinessExtractDataV2::setPartnership()
     * @uses DutchBusinessExtractDataV2::setEnterprise()
     * @uses DutchBusinessExtractDataV2::setEstablishments()
     * @uses DutchBusinessExtractDataV2::setPositions()
     * @uses DutchBusinessExtractDataV2::setRemarks()
     * @param string $dossier_number
     * @param string $reference_date
     * @param \StructType\DutchBusinessLegalEntityV2 $legal_entity
     * @param \StructType\DutchBusinessPartnershipV2 $partnership
     * @param \StructType\DutchBusinessEnterpriseV2 $enterprise
     * @param \ArrayType\DutchBusinessEstablishmentV2Array $establishments
     * @param \ArrayType\DutchBusinessPositionV2Array $positions
     * @param \ArrayType\StringArray $remarks
     */
    public function __construct($dossier_number = null, $reference_date = null, \StructType\DutchBusinessLegalEntityV2 $legal_entity = null, \StructType\DutchBusinessPartnershipV2 $partnership = null, \StructType\DutchBusinessEnterpriseV2 $enterprise = null, \ArrayType\DutchBusinessEstablishmentV2Array $establishments = null, \ArrayType\DutchBusinessPositionV2Array $positions = null, \ArrayType\StringArray $remarks = null)
    {
        $this
            ->setDossier_number($dossier_number)
            ->setReference_date($reference_date)
            ->setLegal_entity($legal_entity)
            ->setPartnership($partnership)
            ->setEnterprise($enterprise)
            ->setEstablishments($establishments)
            ->setPositions($positions)
            ->setRemarks($remarks);
    }
    /**
     * Get dossier_number value
     * @return string|null
     */
    public function getDossier_number()
    {
        return $this->dossier_number;
    }
    /**
     * Set dossier_number value
     * @param string $dossier_number
     * @return \StructType\DutchBusinessExtractDataV2
     */
    public function setDossier_number($dossier_number = null)
    {
        // validation for constraint: string
        if (!is_null($dossier_number) && !is_string($dossier_number)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($dossier_number, true), gettype($dossier_number)), __LINE__);
        }
        $this->dossier_number = $dossier_number;
        return $this;
    }
    /**
     * Get reference_date value
     * @return string|null
     */
    public function getReference_date()
    {
        return $this->reference_date;
    }
    /**
     * Set reference_date value
     * @param string $reference_date
     * @return \StructType\DutchBusinessExtractDataV2
     */
    public function setReference_date($reference_date = null)
    {
        // validation for constraint: string
        if (!is_null($reference_date) && !is_string($reference_date)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($reference_date, true), gettype($reference_date)), __LINE__);
        }
        $this->reference_date = $reference_date;
        return $this;
    }
    /**
     * Get legal_entity value
     * @return \StructType\DutchBusinessLegalEntityV2|null
     */
    public function getLegal_entity()
    {
        return $this->legal_entity;
    }
    /**
     * Set legal_entity value
     * @param \StructType\DutchBusinessLegalEntityV2 $legal_entity
     * @return \StructType\DutchBusinessExtractDataV2
     */
    public function setLegal_entity(\StructType\DutchBusinessLegalEntityV2 $legal_entity = null)
    {
        $this->legal_entity = $legal_entity;
        return $this;
    }
    /**
     * Get partnership value
     * @return \StructType\DutchBusinessPartnershipV2|null
     */
    public function getPartnership()
    {
        return $this->partnership;
    }
    /**
     * Set partnership value
     * @param \StructType\DutchBusinessPartnershipV2 $partnership
     * @return \StructType\DutchBusinessExtractDataV2
     */
    public function setPartnership(\StructType\DutchBusinessPartnershipV2 $partnership = null)
    {
        $this->partnership = $partnership;
        return $this;
    }
    /**
     * Get enterprise value
     * @return \StructType\DutchBusinessEnterpriseV2|null
     */
    public function getEnterprise()
    {
        return $this->enterprise;
    }
    /**
     * Set enterprise value
     * @param \StructType\DutchBusinessEnterpriseV2 $enterprise
     * @return \StructType\DutchBusinessExtractDataV2
     */
    public function setEnterprise(\StructType\DutchBusinessEnterpriseV2 $enterprise = null)
    {
        $this->enterprise = $enterprise;
        return $this;
    }
    /**
     * Get establishments value
     * @return \ArrayType\DutchBusinessEstablishmentV2Array|null
     */
    public function getEstablishments()
    {
        return $this->establishments;
    }
    /**
     * Set establishments value
     * @param \ArrayType\DutchBusinessEstablishmentV2Array $establishments
     * @return \StructType\DutchBusinessExtractDataV2
     */
    public function setEstablishments(\ArrayType\DutchBusinessEstablishmentV2Array $establishments = null)
    {
        $this->establishments = $establishments;
        return $this;
    }
    /**
     * Get positions value
     * @return \ArrayType\DutchBusinessPositionV2Array|null
     */
    public function getPositions()
    {
        return $this->positions;
    }
    /**
     * Set positions value
     * @param \ArrayType\DutchBusinessPositionV2Array $positions
     * @return \StructType\DutchBusinessExtractDataV2
     */
    public function setPositions(\ArrayType\DutchBusinessPositionV2Array $positions = null)
    {
        $this->positions = $positions;
        return $this;
    }
    /**
     * Get remarks value
     * @return \ArrayType\StringArray|null
     */
    public function getRemarks()
    {
        return $this->remarks;
    }
    /**
     * Set remarks value
     * @param \ArrayType\StringArray $remarks
     * @return \StructType\DutchBusinessExtractDataV2
     */
    public function setRemarks(\ArrayType\StringArray $remarks = null)
    {
        $this->remarks = $remarks;
        return $this;
    }
}
