<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for DutchBusinessLeiRegistration StructType
 * @subpackage Structs
 */
class DutchBusinessLeiRegistration extends AbstractStructBase
{
    /**
     * The last_update
     * Meta information extracted from the WSDL
     * - minOccurs: 1
     * @var string
     */
    public $last_update;
    /**
     * The status
     * Meta information extracted from the WSDL
     * - minOccurs: 1
     * @var string
     */
    public $status;
    /**
     * The assignment_date
     * Meta information extracted from the WSDL
     * - minOccurs: 1
     * @var string
     */
    public $assignment_date;
    /**
     * The renewal_date
     * Meta information extracted from the WSDL
     * - minOccurs: 1
     * @var string
     */
    public $renewal_date;
    /**
     * The managing_lou
     * Meta information extracted from the WSDL
     * - minOccurs: 1
     * @var string
     */
    public $managing_lou;
    /**
     * The validation_sources
     * Meta information extracted from the WSDL
     * - minOccurs: 1
     * @var string
     */
    public $validation_sources;
    /**
     * Constructor method for DutchBusinessLeiRegistration
     * @uses DutchBusinessLeiRegistration::setLast_update()
     * @uses DutchBusinessLeiRegistration::setStatus()
     * @uses DutchBusinessLeiRegistration::setAssignment_date()
     * @uses DutchBusinessLeiRegistration::setRenewal_date()
     * @uses DutchBusinessLeiRegistration::setManaging_lou()
     * @uses DutchBusinessLeiRegistration::setValidation_sources()
     * @param string $last_update
     * @param string $status
     * @param string $assignment_date
     * @param string $renewal_date
     * @param string $managing_lou
     * @param string $validation_sources
     */
    public function __construct($last_update = null, $status = null, $assignment_date = null, $renewal_date = null, $managing_lou = null, $validation_sources = null)
    {
        $this
            ->setLast_update($last_update)
            ->setStatus($status)
            ->setAssignment_date($assignment_date)
            ->setRenewal_date($renewal_date)
            ->setManaging_lou($managing_lou)
            ->setValidation_sources($validation_sources);
    }
    /**
     * Get last_update value
     * @return string
     */
    public function getLast_update()
    {
        return $this->last_update;
    }
    /**
     * Set last_update value
     * @param string $last_update
     * @return \StructType\DutchBusinessLeiRegistration
     */
    public function setLast_update($last_update = null)
    {
        // validation for constraint: string
        if (!is_null($last_update) && !is_string($last_update)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($last_update, true), gettype($last_update)), __LINE__);
        }
        $this->last_update = $last_update;
        return $this;
    }
    /**
     * Get status value
     * @return string
     */
    public function getStatus()
    {
        return $this->status;
    }
    /**
     * Set status value
     * @param string $status
     * @return \StructType\DutchBusinessLeiRegistration
     */
    public function setStatus($status = null)
    {
        // validation for constraint: string
        if (!is_null($status) && !is_string($status)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($status, true), gettype($status)), __LINE__);
        }
        $this->status = $status;
        return $this;
    }
    /**
     * Get assignment_date value
     * @return string
     */
    public function getAssignment_date()
    {
        return $this->assignment_date;
    }
    /**
     * Set assignment_date value
     * @param string $assignment_date
     * @return \StructType\DutchBusinessLeiRegistration
     */
    public function setAssignment_date($assignment_date = null)
    {
        // validation for constraint: string
        if (!is_null($assignment_date) && !is_string($assignment_date)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($assignment_date, true), gettype($assignment_date)), __LINE__);
        }
        $this->assignment_date = $assignment_date;
        return $this;
    }
    /**
     * Get renewal_date value
     * @return string
     */
    public function getRenewal_date()
    {
        return $this->renewal_date;
    }
    /**
     * Set renewal_date value
     * @param string $renewal_date
     * @return \StructType\DutchBusinessLeiRegistration
     */
    public function setRenewal_date($renewal_date = null)
    {
        // validation for constraint: string
        if (!is_null($renewal_date) && !is_string($renewal_date)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($renewal_date, true), gettype($renewal_date)), __LINE__);
        }
        $this->renewal_date = $renewal_date;
        return $this;
    }
    /**
     * Get managing_lou value
     * @return string
     */
    public function getManaging_lou()
    {
        return $this->managing_lou;
    }
    /**
     * Set managing_lou value
     * @param string $managing_lou
     * @return \StructType\DutchBusinessLeiRegistration
     */
    public function setManaging_lou($managing_lou = null)
    {
        // validation for constraint: string
        if (!is_null($managing_lou) && !is_string($managing_lou)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($managing_lou, true), gettype($managing_lou)), __LINE__);
        }
        $this->managing_lou = $managing_lou;
        return $this;
    }
    /**
     * Get validation_sources value
     * @return string
     */
    public function getValidation_sources()
    {
        return $this->validation_sources;
    }
    /**
     * Set validation_sources value
     * @param string $validation_sources
     * @return \StructType\DutchBusinessLeiRegistration
     */
    public function setValidation_sources($validation_sources = null)
    {
        // validation for constraint: string
        if (!is_null($validation_sources) && !is_string($validation_sources)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($validation_sources, true), gettype($validation_sources)), __LINE__);
        }
        $this->validation_sources = $validation_sources;
        return $this;
    }
}
