<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for DutchBusinessPositionAuthorization StructType
 * @subpackage Structs
 */
class DutchBusinessPositionAuthorization extends AbstractStructBase
{
    /**
     * The start_date
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $start_date;
    /**
     * The end_date
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $end_date;
    /**
     * The end_date_source
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $end_date_source;
    /**
     * The description
     * @var string
     */
    public $description;
    /**
     * Constructor method for DutchBusinessPositionAuthorization
     * @uses DutchBusinessPositionAuthorization::setStart_date()
     * @uses DutchBusinessPositionAuthorization::setEnd_date()
     * @uses DutchBusinessPositionAuthorization::setEnd_date_source()
     * @uses DutchBusinessPositionAuthorization::setDescription()
     * @param string $start_date
     * @param string $end_date
     * @param string $end_date_source
     * @param string $description
     */
    public function __construct($start_date = null, $end_date = null, $end_date_source = null, $description = null)
    {
        $this
            ->setStart_date($start_date)
            ->setEnd_date($end_date)
            ->setEnd_date_source($end_date_source)
            ->setDescription($description);
    }
    /**
     * Get start_date value
     * @return string|null
     */
    public function getStart_date()
    {
        return $this->start_date;
    }
    /**
     * Set start_date value
     * @param string $start_date
     * @return \StructType\DutchBusinessPositionAuthorization
     */
    public function setStart_date($start_date = null)
    {
        // validation for constraint: string
        if (!is_null($start_date) && !is_string($start_date)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($start_date, true), gettype($start_date)), __LINE__);
        }
        $this->start_date = $start_date;
        return $this;
    }
    /**
     * Get end_date value
     * @return string|null
     */
    public function getEnd_date()
    {
        return $this->end_date;
    }
    /**
     * Set end_date value
     * @param string $end_date
     * @return \StructType\DutchBusinessPositionAuthorization
     */
    public function setEnd_date($end_date = null)
    {
        // validation for constraint: string
        if (!is_null($end_date) && !is_string($end_date)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($end_date, true), gettype($end_date)), __LINE__);
        }
        $this->end_date = $end_date;
        return $this;
    }
    /**
     * Get end_date_source value
     * @return string|null
     */
    public function getEnd_date_source()
    {
        return $this->end_date_source;
    }
    /**
     * Set end_date_source value
     * @param string $end_date_source
     * @return \StructType\DutchBusinessPositionAuthorization
     */
    public function setEnd_date_source($end_date_source = null)
    {
        // validation for constraint: string
        if (!is_null($end_date_source) && !is_string($end_date_source)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($end_date_source, true), gettype($end_date_source)), __LINE__);
        }
        $this->end_date_source = $end_date_source;
        return $this;
    }
    /**
     * Get description value
     * @return string|null
     */
    public function getDescription()
    {
        return $this->description;
    }
    /**
     * Set description value
     * @param string $description
     * @return \StructType\DutchBusinessPositionAuthorization
     */
    public function setDescription($description = null)
    {
        // validation for constraint: string
        if (!is_null($description) && !is_string($description)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($description, true), gettype($description)), __LINE__);
        }
        $this->description = $description;
        return $this;
    }
}
