<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for DutchBusinessPositions StructType
 * @subpackage Structs
 */
class DutchBusinessPositions extends AbstractStructBase
{
    /**
     * The dossier_number
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $dossier_number;
    /**
     * The reference_date
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $reference_date;
    /**
     * The positions
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \ArrayType\DutchBusinessPositionV2Array
     */
    public $positions;
    /**
     * Constructor method for DutchBusinessPositions
     * @uses DutchBusinessPositions::setDossier_number()
     * @uses DutchBusinessPositions::setReference_date()
     * @uses DutchBusinessPositions::setPositions()
     * @param string $dossier_number
     * @param string $reference_date
     * @param \ArrayType\DutchBusinessPositionV2Array $positions
     */
    public function __construct($dossier_number = null, $reference_date = null, \ArrayType\DutchBusinessPositionV2Array $positions = null)
    {
        $this
            ->setDossier_number($dossier_number)
            ->setReference_date($reference_date)
            ->setPositions($positions);
    }
    /**
     * Get dossier_number value
     * @return string|null
     */
    public function getDossier_number()
    {
        return $this->dossier_number;
    }
    /**
     * Set dossier_number value
     * @param string $dossier_number
     * @return \StructType\DutchBusinessPositions
     */
    public function setDossier_number($dossier_number = null)
    {
        // validation for constraint: string
        if (!is_null($dossier_number) && !is_string($dossier_number)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($dossier_number, true), gettype($dossier_number)), __LINE__);
        }
        $this->dossier_number = $dossier_number;
        return $this;
    }
    /**
     * Get reference_date value
     * @return string|null
     */
    public function getReference_date()
    {
        return $this->reference_date;
    }
    /**
     * Set reference_date value
     * @param string $reference_date
     * @return \StructType\DutchBusinessPositions
     */
    public function setReference_date($reference_date = null)
    {
        // validation for constraint: string
        if (!is_null($reference_date) && !is_string($reference_date)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($reference_date, true), gettype($reference_date)), __LINE__);
        }
        $this->reference_date = $reference_date;
        return $this;
    }
    /**
     * Get positions value
     * @return \ArrayType\DutchBusinessPositionV2Array|null
     */
    public function getPositions()
    {
        return $this->positions;
    }
    /**
     * Set positions value
     * @param \ArrayType\DutchBusinessPositionV2Array $positions
     * @return \StructType\DutchBusinessPositions
     */
    public function setPositions(\ArrayType\DutchBusinessPositionV2Array $positions = null)
    {
        $this->positions = $positions;
        return $this;
    }
}
