<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for DutchBusinessUBOClassificationResult StructType
 * @subpackage Structs
 */
class DutchBusinessUBOClassificationResult extends AbstractStructBase
{
    /**
     * The token
     * Meta information extracted from the WSDL
     * - minOccurs: 1
     * @var string
     */
    public $token;
    /**
     * The scenario
     * Meta information extracted from the WSDL
     * - minOccurs: 1
     * @var string
     */
    public $scenario;
    /**
     * The suspects
     * Meta information extracted from the WSDL
     * - minOccurs: 1
     * @var \ArrayType\DutchBusinessUBOClassifiedSuspectArray
     */
    public $suspects;
    /**
     * Constructor method for DutchBusinessUBOClassificationResult
     * @uses DutchBusinessUBOClassificationResult::setToken()
     * @uses DutchBusinessUBOClassificationResult::setScenario()
     * @uses DutchBusinessUBOClassificationResult::setSuspects()
     * @param string $token
     * @param string $scenario
     * @param \ArrayType\DutchBusinessUBOClassifiedSuspectArray $suspects
     */
    public function __construct($token = null, $scenario = null, \ArrayType\DutchBusinessUBOClassifiedSuspectArray $suspects = null)
    {
        $this
            ->setToken($token)
            ->setScenario($scenario)
            ->setSuspects($suspects);
    }
    /**
     * Get token value
     * @return string
     */
    public function getToken()
    {
        return $this->token;
    }
    /**
     * Set token value
     * @param string $token
     * @return \StructType\DutchBusinessUBOClassificationResult
     */
    public function setToken($token = null)
    {
        // validation for constraint: string
        if (!is_null($token) && !is_string($token)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($token, true), gettype($token)), __LINE__);
        }
        $this->token = $token;
        return $this;
    }
    /**
     * Get scenario value
     * @return string
     */
    public function getScenario()
    {
        return $this->scenario;
    }
    /**
     * Set scenario value
     * @param string $scenario
     * @return \StructType\DutchBusinessUBOClassificationResult
     */
    public function setScenario($scenario = null)
    {
        // validation for constraint: string
        if (!is_null($scenario) && !is_string($scenario)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($scenario, true), gettype($scenario)), __LINE__);
        }
        $this->scenario = $scenario;
        return $this;
    }
    /**
     * Get suspects value
     * @return \ArrayType\DutchBusinessUBOClassifiedSuspectArray
     */
    public function getSuspects()
    {
        return $this->suspects;
    }
    /**
     * Set suspects value
     * @param \ArrayType\DutchBusinessUBOClassifiedSuspectArray $suspects
     * @return \StructType\DutchBusinessUBOClassificationResult
     */
    public function setSuspects(\ArrayType\DutchBusinessUBOClassifiedSuspectArray $suspects = null)
    {
        $this->suspects = $suspects;
        return $this;
    }
}
