<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for DutchVehicleTaxData StructType
 * @subpackage Structs
 */
class DutchVehicleTaxData extends AbstractStructBase
{
    /**
     * The amount
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $amount;
    /**
     * The base
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $base;
    /**
     * Constructor method for DutchVehicleTaxData
     * @uses DutchVehicleTaxData::setAmount()
     * @uses DutchVehicleTaxData::setBase()
     * @param int $amount
     * @param string $base
     */
    public function __construct($amount = null, $base = null)
    {
        $this
            ->setAmount($amount)
            ->setBase($base);
    }
    /**
     * Get amount value
     * @return int|null
     */
    public function getAmount()
    {
        return $this->amount;
    }
    /**
     * Set amount value
     * @param int $amount
     * @return \StructType\DutchVehicleTaxData
     */
    public function setAmount($amount = null)
    {
        // validation for constraint: int
        if (!is_null($amount) && !(is_int($amount) || ctype_digit($amount))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($amount, true), gettype($amount)), __LINE__);
        }
        $this->amount = $amount;
        return $this;
    }
    /**
     * Get base value
     * @return string|null
     */
    public function getBase()
    {
        return $this->base;
    }
    /**
     * Set base value
     * @param string $base
     * @return \StructType\DutchVehicleTaxData
     */
    public function setBase($base = null)
    {
        // validation for constraint: string
        if (!is_null($base) && !is_string($base)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($base, true), gettype($base)), __LINE__);
        }
        $this->base = $base;
        return $this;
    }
}
