<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GCRCreditFactor StructType
 * @subpackage Structs
 */
class GCRCreditFactor extends AbstractStructBase
{
    /**
     * The type
     * @var string
     */
    public $type;
    /**
     * The description
     * @var string
     */
    public $description;
    /**
     * The adjustment
     * @var int
     */
    public $adjustment;
    /**
     * Constructor method for GCRCreditFactor
     * @uses GCRCreditFactor::setType()
     * @uses GCRCreditFactor::setDescription()
     * @uses GCRCreditFactor::setAdjustment()
     * @param string $type
     * @param string $description
     * @param int $adjustment
     */
    public function __construct($type = null, $description = null, $adjustment = null)
    {
        $this
            ->setType($type)
            ->setDescription($description)
            ->setAdjustment($adjustment);
    }
    /**
     * Get type value
     * @return string|null
     */
    public function getType()
    {
        return $this->type;
    }
    /**
     * Set type value
     * @param string $type
     * @return \StructType\GCRCreditFactor
     */
    public function setType($type = null)
    {
        // validation for constraint: string
        if (!is_null($type) && !is_string($type)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($type, true), gettype($type)), __LINE__);
        }
        $this->type = $type;
        return $this;
    }
    /**
     * Get description value
     * @return string|null
     */
    public function getDescription()
    {
        return $this->description;
    }
    /**
     * Set description value
     * @param string $description
     * @return \StructType\GCRCreditFactor
     */
    public function setDescription($description = null)
    {
        // validation for constraint: string
        if (!is_null($description) && !is_string($description)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($description, true), gettype($description)), __LINE__);
        }
        $this->description = $description;
        return $this;
    }
    /**
     * Get adjustment value
     * @return int|null
     */
    public function getAdjustment()
    {
        return $this->adjustment;
    }
    /**
     * Set adjustment value
     * @param int $adjustment
     * @return \StructType\GCRCreditFactor
     */
    public function setAdjustment($adjustment = null)
    {
        // validation for constraint: int
        if (!is_null($adjustment) && !(is_int($adjustment) || ctype_digit($adjustment))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($adjustment, true), gettype($adjustment)), __LINE__);
        }
        $this->adjustment = $adjustment;
        return $this;
    }
}
