<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GCRLiaisonCompany StructType
 * @subpackage Structs
 */
class GCRLiaisonCompany extends AbstractStructBase
{
    /**
     * The graydon_company_id
     * @var int
     */
    public $graydon_company_id;
    /**
     * The contact_details
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\GCRLiaisonContactDetails
     */
    public $contact_details;
    /**
     * The official_data
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\GCRLiaisonOfficialData
     */
    public $official_data;
    /**
     * The financial_calamities
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \ArrayType\GCRFinancialCalamityArray
     */
    public $financial_calamities;
    /**
     * Constructor method for GCRLiaisonCompany
     * @uses GCRLiaisonCompany::setGraydon_company_id()
     * @uses GCRLiaisonCompany::setContact_details()
     * @uses GCRLiaisonCompany::setOfficial_data()
     * @uses GCRLiaisonCompany::setFinancial_calamities()
     * @param int $graydon_company_id
     * @param \StructType\GCRLiaisonContactDetails $contact_details
     * @param \StructType\GCRLiaisonOfficialData $official_data
     * @param \ArrayType\GCRFinancialCalamityArray $financial_calamities
     */
    public function __construct($graydon_company_id = null, \StructType\GCRLiaisonContactDetails $contact_details = null, \StructType\GCRLiaisonOfficialData $official_data = null, \ArrayType\GCRFinancialCalamityArray $financial_calamities = null)
    {
        $this
            ->setGraydon_company_id($graydon_company_id)
            ->setContact_details($contact_details)
            ->setOfficial_data($official_data)
            ->setFinancial_calamities($financial_calamities);
    }
    /**
     * Get graydon_company_id value
     * @return int|null
     */
    public function getGraydon_company_id()
    {
        return $this->graydon_company_id;
    }
    /**
     * Set graydon_company_id value
     * @param int $graydon_company_id
     * @return \StructType\GCRLiaisonCompany
     */
    public function setGraydon_company_id($graydon_company_id = null)
    {
        // validation for constraint: int
        if (!is_null($graydon_company_id) && !(is_int($graydon_company_id) || ctype_digit($graydon_company_id))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($graydon_company_id, true), gettype($graydon_company_id)), __LINE__);
        }
        $this->graydon_company_id = $graydon_company_id;
        return $this;
    }
    /**
     * Get contact_details value
     * @return \StructType\GCRLiaisonContactDetails|null
     */
    public function getContact_details()
    {
        return $this->contact_details;
    }
    /**
     * Set contact_details value
     * @param \StructType\GCRLiaisonContactDetails $contact_details
     * @return \StructType\GCRLiaisonCompany
     */
    public function setContact_details(\StructType\GCRLiaisonContactDetails $contact_details = null)
    {
        $this->contact_details = $contact_details;
        return $this;
    }
    /**
     * Get official_data value
     * @return \StructType\GCRLiaisonOfficialData|null
     */
    public function getOfficial_data()
    {
        return $this->official_data;
    }
    /**
     * Set official_data value
     * @param \StructType\GCRLiaisonOfficialData $official_data
     * @return \StructType\GCRLiaisonCompany
     */
    public function setOfficial_data(\StructType\GCRLiaisonOfficialData $official_data = null)
    {
        $this->official_data = $official_data;
        return $this;
    }
    /**
     * Get financial_calamities value
     * @return \ArrayType\GCRFinancialCalamityArray|null
     */
    public function getFinancial_calamities()
    {
        return $this->financial_calamities;
    }
    /**
     * Set financial_calamities value
     * @param \ArrayType\GCRFinancialCalamityArray $financial_calamities
     * @return \StructType\GCRLiaisonCompany
     */
    public function setFinancial_calamities(\ArrayType\GCRFinancialCalamityArray $financial_calamities = null)
    {
        $this->financial_calamities = $financial_calamities;
        return $this;
    }
}
