<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GCRManagement StructType
 * @subpackage Structs
 */
class GCRManagement extends AbstractStructBase
{
    /**
     * The graydon_company_id
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $graydon_company_id;
    /**
     * The graydon_person_id
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $graydon_person_id;
    /**
     * The is_current
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $is_current;
    /**
     * The job_titles
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \ArrayType\GCRJobTitleArray
     */
    public $job_titles;
    /**
     * Constructor method for GCRManagement
     * @uses GCRManagement::setGraydon_company_id()
     * @uses GCRManagement::setGraydon_person_id()
     * @uses GCRManagement::setIs_current()
     * @uses GCRManagement::setJob_titles()
     * @param int $graydon_company_id
     * @param int $graydon_person_id
     * @param bool $is_current
     * @param \ArrayType\GCRJobTitleArray $job_titles
     */
    public function __construct($graydon_company_id = null, $graydon_person_id = null, $is_current = null, \ArrayType\GCRJobTitleArray $job_titles = null)
    {
        $this
            ->setGraydon_company_id($graydon_company_id)
            ->setGraydon_person_id($graydon_person_id)
            ->setIs_current($is_current)
            ->setJob_titles($job_titles);
    }
    /**
     * Get graydon_company_id value
     * @return int|null
     */
    public function getGraydon_company_id()
    {
        return $this->graydon_company_id;
    }
    /**
     * Set graydon_company_id value
     * @param int $graydon_company_id
     * @return \StructType\GCRManagement
     */
    public function setGraydon_company_id($graydon_company_id = null)
    {
        // validation for constraint: int
        if (!is_null($graydon_company_id) && !(is_int($graydon_company_id) || ctype_digit($graydon_company_id))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($graydon_company_id, true), gettype($graydon_company_id)), __LINE__);
        }
        $this->graydon_company_id = $graydon_company_id;
        return $this;
    }
    /**
     * Get graydon_person_id value
     * @return int|null
     */
    public function getGraydon_person_id()
    {
        return $this->graydon_person_id;
    }
    /**
     * Set graydon_person_id value
     * @param int $graydon_person_id
     * @return \StructType\GCRManagement
     */
    public function setGraydon_person_id($graydon_person_id = null)
    {
        // validation for constraint: int
        if (!is_null($graydon_person_id) && !(is_int($graydon_person_id) || ctype_digit($graydon_person_id))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($graydon_person_id, true), gettype($graydon_person_id)), __LINE__);
        }
        $this->graydon_person_id = $graydon_person_id;
        return $this;
    }
    /**
     * Get is_current value
     * @return bool|null
     */
    public function getIs_current()
    {
        return $this->is_current;
    }
    /**
     * Set is_current value
     * @param bool $is_current
     * @return \StructType\GCRManagement
     */
    public function setIs_current($is_current = null)
    {
        // validation for constraint: boolean
        if (!is_null($is_current) && !is_bool($is_current)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($is_current, true), gettype($is_current)), __LINE__);
        }
        $this->is_current = $is_current;
        return $this;
    }
    /**
     * Get job_titles value
     * @return \ArrayType\GCRJobTitleArray|null
     */
    public function getJob_titles()
    {
        return $this->job_titles;
    }
    /**
     * Set job_titles value
     * @param \ArrayType\GCRJobTitleArray $job_titles
     * @return \StructType\GCRManagement
     */
    public function setJob_titles(\ArrayType\GCRJobTitleArray $job_titles = null)
    {
        $this->job_titles = $job_titles;
        return $this;
    }
}
