<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for geoLocationAddressCoordinatesRDRequestType StructType
 * @subpackage Structs
 */
class GeoLocationAddressCoordinatesRDRequestType extends AbstractStructBase
{
    /**
     * The postcode
     * @var string
     */
    public $postcode;
    /**
     * The city
     * @var string
     */
    public $city;
    /**
     * The street
     * @var string
     */
    public $street;
    /**
     * The houseno
     * @var int
     */
    public $houseno;
    /**
     * Constructor method for geoLocationAddressCoordinatesRDRequestType
     * @uses GeoLocationAddressCoordinatesRDRequestType::setPostcode()
     * @uses GeoLocationAddressCoordinatesRDRequestType::setCity()
     * @uses GeoLocationAddressCoordinatesRDRequestType::setStreet()
     * @uses GeoLocationAddressCoordinatesRDRequestType::setHouseno()
     * @param string $postcode
     * @param string $city
     * @param string $street
     * @param int $houseno
     */
    public function __construct($postcode = null, $city = null, $street = null, $houseno = null)
    {
        $this
            ->setPostcode($postcode)
            ->setCity($city)
            ->setStreet($street)
            ->setHouseno($houseno);
    }
    /**
     * Get postcode value
     * @return string|null
     */
    public function getPostcode()
    {
        return $this->postcode;
    }
    /**
     * Set postcode value
     * @param string $postcode
     * @return \StructType\GeoLocationAddressCoordinatesRDRequestType
     */
    public function setPostcode($postcode = null)
    {
        // validation for constraint: string
        if (!is_null($postcode) && !is_string($postcode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($postcode, true), gettype($postcode)), __LINE__);
        }
        $this->postcode = $postcode;
        return $this;
    }
    /**
     * Get city value
     * @return string|null
     */
    public function getCity()
    {
        return $this->city;
    }
    /**
     * Set city value
     * @param string $city
     * @return \StructType\GeoLocationAddressCoordinatesRDRequestType
     */
    public function setCity($city = null)
    {
        // validation for constraint: string
        if (!is_null($city) && !is_string($city)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($city, true), gettype($city)), __LINE__);
        }
        $this->city = $city;
        return $this;
    }
    /**
     * Get street value
     * @return string|null
     */
    public function getStreet()
    {
        return $this->street;
    }
    /**
     * Set street value
     * @param string $street
     * @return \StructType\GeoLocationAddressCoordinatesRDRequestType
     */
    public function setStreet($street = null)
    {
        // validation for constraint: string
        if (!is_null($street) && !is_string($street)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($street, true), gettype($street)), __LINE__);
        }
        $this->street = $street;
        return $this;
    }
    /**
     * Get houseno value
     * @return int|null
     */
    public function getHouseno()
    {
        return $this->houseno;
    }
    /**
     * Set houseno value
     * @param int $houseno
     * @return \StructType\GeoLocationAddressCoordinatesRDRequestType
     */
    public function setHouseno($houseno = null)
    {
        // validation for constraint: int
        if (!is_null($houseno) && !(is_int($houseno) || ctype_digit($houseno))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($houseno, true), gettype($houseno)), __LINE__);
        }
        $this->houseno = $houseno;
        return $this;
    }
}
