<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for geoLocationDistanceSortedPostcodesRadiusRequestType
 * StructType
 * @subpackage Structs
 */
class GeoLocationDistanceSortedPostcodesRadiusRequestType extends AbstractStructBase
{
    /**
     * The postcodefrom
     * @var string
     */
    public $postcodefrom;
    /**
     * The radius
     * @var int
     */
    public $radius;
    /**
     * The page
     * @var int
     */
    public $page;
    /**
     * Constructor method for geoLocationDistanceSortedPostcodesRadiusRequestType
     * @uses GeoLocationDistanceSortedPostcodesRadiusRequestType::setPostcodefrom()
     * @uses GeoLocationDistanceSortedPostcodesRadiusRequestType::setRadius()
     * @uses GeoLocationDistanceSortedPostcodesRadiusRequestType::setPage()
     * @param string $postcodefrom
     * @param int $radius
     * @param int $page
     */
    public function __construct($postcodefrom = null, $radius = null, $page = null)
    {
        $this
            ->setPostcodefrom($postcodefrom)
            ->setRadius($radius)
            ->setPage($page);
    }
    /**
     * Get postcodefrom value
     * @return string|null
     */
    public function getPostcodefrom()
    {
        return $this->postcodefrom;
    }
    /**
     * Set postcodefrom value
     * @param string $postcodefrom
     * @return \StructType\GeoLocationDistanceSortedPostcodesRadiusRequestType
     */
    public function setPostcodefrom($postcodefrom = null)
    {
        // validation for constraint: string
        if (!is_null($postcodefrom) && !is_string($postcodefrom)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($postcodefrom, true), gettype($postcodefrom)), __LINE__);
        }
        $this->postcodefrom = $postcodefrom;
        return $this;
    }
    /**
     * Get radius value
     * @return int|null
     */
    public function getRadius()
    {
        return $this->radius;
    }
    /**
     * Set radius value
     * @param int $radius
     * @return \StructType\GeoLocationDistanceSortedPostcodesRadiusRequestType
     */
    public function setRadius($radius = null)
    {
        // validation for constraint: int
        if (!is_null($radius) && !(is_int($radius) || ctype_digit($radius))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($radius, true), gettype($radius)), __LINE__);
        }
        $this->radius = $radius;
        return $this;
    }
    /**
     * Get page value
     * @return int|null
     */
    public function getPage()
    {
        return $this->page;
    }
    /**
     * Set page value
     * @param int $page
     * @return \StructType\GeoLocationDistanceSortedPostcodesRadiusRequestType
     */
    public function setPage($page = null)
    {
        // validation for constraint: int
        if (!is_null($page) && !(is_int($page) || ctype_digit($page))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($page, true), gettype($page)), __LINE__);
        }
        $this->page = $page;
        return $this;
    }
}
