<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for KadasterBronDocument StructType
 * @subpackage Structs
 */
class KadasterBronDocument extends AbstractStructBase
{
    /**
     * The document
     * @var string
     */
    public $document;
    /**
     * The images
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \ArrayType\Base64BinaryArray
     */
    public $images;
    /**
     * Constructor method for KadasterBronDocument
     * @uses KadasterBronDocument::setDocument()
     * @uses KadasterBronDocument::setImages()
     * @param string $document
     * @param \ArrayType\Base64BinaryArray $images
     */
    public function __construct($document = null, \ArrayType\Base64BinaryArray $images = null)
    {
        $this
            ->setDocument($document)
            ->setImages($images);
    }
    /**
     * Get document value
     * @return string|null
     */
    public function getDocument()
    {
        return $this->document;
    }
    /**
     * Set document value
     * @param string $document
     * @return \StructType\KadasterBronDocument
     */
    public function setDocument($document = null)
    {
        // validation for constraint: string
        if (!is_null($document) && !is_string($document)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($document, true), gettype($document)), __LINE__);
        }
        $this->document = $document;
        return $this;
    }
    /**
     * Get images value
     * @return \ArrayType\Base64BinaryArray|null
     */
    public function getImages()
    {
        return $this->images;
    }
    /**
     * Set images value
     * @param \ArrayType\Base64BinaryArray $images
     * @return \StructType\KadasterBronDocument
     */
    public function setImages(\ArrayType\Base64BinaryArray $images = null)
    {
        $this->images = $images;
        return $this;
    }
}
