<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for KadasterV2Bedrag StructType
 * @subpackage Structs
 */
class KadasterV2Bedrag extends AbstractStructBase
{
    /**
     * The som
     * Meta information extracted from the WSDL
     * - minOccurs: 1
     * @var float
     */
    public $som;
    /**
     * The valuta
     * Meta information extracted from the WSDL
     * - minOccurs: 1
     * @var string
     */
    public $valuta;
    /**
     * Constructor method for KadasterV2Bedrag
     * @uses KadasterV2Bedrag::setSom()
     * @uses KadasterV2Bedrag::setValuta()
     * @param float $som
     * @param string $valuta
     */
    public function __construct($som = null, $valuta = null)
    {
        $this
            ->setSom($som)
            ->setValuta($valuta);
    }
    /**
     * Get som value
     * @return float
     */
    public function getSom()
    {
        return $this->som;
    }
    /**
     * Set som value
     * @param float $som
     * @return \StructType\KadasterV2Bedrag
     */
    public function setSom($som = null)
    {
        // validation for constraint: float
        if (!is_null($som) && !(is_float($som) || is_numeric($som))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($som, true), gettype($som)), __LINE__);
        }
        $this->som = $som;
        return $this;
    }
    /**
     * Get valuta value
     * @return string
     */
    public function getValuta()
    {
        return $this->valuta;
    }
    /**
     * Set valuta value
     * @param string $valuta
     * @return \StructType\KadasterV2Bedrag
     */
    public function setValuta($valuta = null)
    {
        // validation for constraint: string
        if (!is_null($valuta) && !is_string($valuta)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($valuta, true), gettype($valuta)), __LINE__);
        }
        $this->valuta = $valuta;
        return $this;
    }
}
