<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for KadasterV2LocatieBinnenland StructType
 * @subpackage Structs
 */
class KadasterV2LocatieBinnenland extends AbstractStructBase
{
    /**
     * The identificatie
     * Meta information extracted from the WSDL
     * - minOccurs: 1
     * @var string
     */
    public $identificatie;
    /**
     * The straatnaam
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $straatnaam;
    /**
     * The huisnummer
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $huisnummer;
    /**
     * The huisletter
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $huisletter;
    /**
     * The huisnummertoevoeging
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $huisnummertoevoeging;
    /**
     * The postcode
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $postcode;
    /**
     * The in_onderzoek
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $in_onderzoek;
    /**
     * The woonplaats
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $woonplaats;
    /**
     * Constructor method for KadasterV2LocatieBinnenland
     * @uses KadasterV2LocatieBinnenland::setIdentificatie()
     * @uses KadasterV2LocatieBinnenland::setStraatnaam()
     * @uses KadasterV2LocatieBinnenland::setHuisnummer()
     * @uses KadasterV2LocatieBinnenland::setHuisletter()
     * @uses KadasterV2LocatieBinnenland::setHuisnummertoevoeging()
     * @uses KadasterV2LocatieBinnenland::setPostcode()
     * @uses KadasterV2LocatieBinnenland::setIn_onderzoek()
     * @uses KadasterV2LocatieBinnenland::setWoonplaats()
     * @param string $identificatie
     * @param string $straatnaam
     * @param int $huisnummer
     * @param string $huisletter
     * @param string $huisnummertoevoeging
     * @param string $postcode
     * @param string $in_onderzoek
     * @param string $woonplaats
     */
    public function __construct($identificatie = null, $straatnaam = null, $huisnummer = null, $huisletter = null, $huisnummertoevoeging = null, $postcode = null, $in_onderzoek = null, $woonplaats = null)
    {
        $this
            ->setIdentificatie($identificatie)
            ->setStraatnaam($straatnaam)
            ->setHuisnummer($huisnummer)
            ->setHuisletter($huisletter)
            ->setHuisnummertoevoeging($huisnummertoevoeging)
            ->setPostcode($postcode)
            ->setIn_onderzoek($in_onderzoek)
            ->setWoonplaats($woonplaats);
    }
    /**
     * Get identificatie value
     * @return string
     */
    public function getIdentificatie()
    {
        return $this->identificatie;
    }
    /**
     * Set identificatie value
     * @param string $identificatie
     * @return \StructType\KadasterV2LocatieBinnenland
     */
    public function setIdentificatie($identificatie = null)
    {
        // validation for constraint: string
        if (!is_null($identificatie) && !is_string($identificatie)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($identificatie, true), gettype($identificatie)), __LINE__);
        }
        $this->identificatie = $identificatie;
        return $this;
    }
    /**
     * Get straatnaam value
     * @return string|null
     */
    public function getStraatnaam()
    {
        return $this->straatnaam;
    }
    /**
     * Set straatnaam value
     * @param string $straatnaam
     * @return \StructType\KadasterV2LocatieBinnenland
     */
    public function setStraatnaam($straatnaam = null)
    {
        // validation for constraint: string
        if (!is_null($straatnaam) && !is_string($straatnaam)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($straatnaam, true), gettype($straatnaam)), __LINE__);
        }
        $this->straatnaam = $straatnaam;
        return $this;
    }
    /**
     * Get huisnummer value
     * @return int|null
     */
    public function getHuisnummer()
    {
        return $this->huisnummer;
    }
    /**
     * Set huisnummer value
     * @param int $huisnummer
     * @return \StructType\KadasterV2LocatieBinnenland
     */
    public function setHuisnummer($huisnummer = null)
    {
        // validation for constraint: int
        if (!is_null($huisnummer) && !(is_int($huisnummer) || ctype_digit($huisnummer))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($huisnummer, true), gettype($huisnummer)), __LINE__);
        }
        $this->huisnummer = $huisnummer;
        return $this;
    }
    /**
     * Get huisletter value
     * @return string|null
     */
    public function getHuisletter()
    {
        return $this->huisletter;
    }
    /**
     * Set huisletter value
     * @param string $huisletter
     * @return \StructType\KadasterV2LocatieBinnenland
     */
    public function setHuisletter($huisletter = null)
    {
        // validation for constraint: string
        if (!is_null($huisletter) && !is_string($huisletter)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($huisletter, true), gettype($huisletter)), __LINE__);
        }
        $this->huisletter = $huisletter;
        return $this;
    }
    /**
     * Get huisnummertoevoeging value
     * @return string|null
     */
    public function getHuisnummertoevoeging()
    {
        return $this->huisnummertoevoeging;
    }
    /**
     * Set huisnummertoevoeging value
     * @param string $huisnummertoevoeging
     * @return \StructType\KadasterV2LocatieBinnenland
     */
    public function setHuisnummertoevoeging($huisnummertoevoeging = null)
    {
        // validation for constraint: string
        if (!is_null($huisnummertoevoeging) && !is_string($huisnummertoevoeging)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($huisnummertoevoeging, true), gettype($huisnummertoevoeging)), __LINE__);
        }
        $this->huisnummertoevoeging = $huisnummertoevoeging;
        return $this;
    }
    /**
     * Get postcode value
     * @return string|null
     */
    public function getPostcode()
    {
        return $this->postcode;
    }
    /**
     * Set postcode value
     * @param string $postcode
     * @return \StructType\KadasterV2LocatieBinnenland
     */
    public function setPostcode($postcode = null)
    {
        // validation for constraint: string
        if (!is_null($postcode) && !is_string($postcode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($postcode, true), gettype($postcode)), __LINE__);
        }
        $this->postcode = $postcode;
        return $this;
    }
    /**
     * Get in_onderzoek value
     * @return string|null
     */
    public function getIn_onderzoek()
    {
        return $this->in_onderzoek;
    }
    /**
     * Set in_onderzoek value
     * @param string $in_onderzoek
     * @return \StructType\KadasterV2LocatieBinnenland
     */
    public function setIn_onderzoek($in_onderzoek = null)
    {
        // validation for constraint: string
        if (!is_null($in_onderzoek) && !is_string($in_onderzoek)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($in_onderzoek, true), gettype($in_onderzoek)), __LINE__);
        }
        $this->in_onderzoek = $in_onderzoek;
        return $this;
    }
    /**
     * Get woonplaats value
     * @return string|null
     */
    public function getWoonplaats()
    {
        return $this->woonplaats;
    }
    /**
     * Set woonplaats value
     * @param string $woonplaats
     * @return \StructType\KadasterV2LocatieBinnenland
     */
    public function setWoonplaats($woonplaats = null)
    {
        // validation for constraint: string
        if (!is_null($woonplaats) && !is_string($woonplaats)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($woonplaats, true), gettype($woonplaats)), __LINE__);
        }
        $this->woonplaats = $woonplaats;
        return $this;
    }
}
