<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for KvkExtractDocument StructType
 * @subpackage Structs
 */
class KvkExtractDocument extends AbstractStructBase
{
    /**
     * The document
     * @var string
     */
    public $document;
    /**
     * The document_date
     * @var string
     */
    public $document_date;
    /**
     * Constructor method for KvkExtractDocument
     * @uses KvkExtractDocument::setDocument()
     * @uses KvkExtractDocument::setDocument_date()
     * @param string $document
     * @param string $document_date
     */
    public function __construct($document = null, $document_date = null)
    {
        $this
            ->setDocument($document)
            ->setDocument_date($document_date);
    }
    /**
     * Get document value
     * @return string|null
     */
    public function getDocument()
    {
        return $this->document;
    }
    /**
     * Set document value
     * @param string $document
     * @return \StructType\KvkExtractDocument
     */
    public function setDocument($document = null)
    {
        // validation for constraint: string
        if (!is_null($document) && !is_string($document)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($document, true), gettype($document)), __LINE__);
        }
        $this->document = $document;
        return $this;
    }
    /**
     * Get document_date value
     * @return string|null
     */
    public function getDocument_date()
    {
        return $this->document_date;
    }
    /**
     * Set document_date value
     * @param string $document_date
     * @return \StructType\KvkExtractDocument
     */
    public function setDocument_date($document_date = null)
    {
        // validation for constraint: string
        if (!is_null($document_date) && !is_string($document_date)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($document_date, true), gettype($document_date)), __LINE__);
        }
        $this->document_date = $document_date;
        return $this;
    }
}
