<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for LatLonCoordinatesMatch StructType
 * @subpackage Structs
 */
class LatLonCoordinatesMatch extends AbstractStructBase
{
    /**
     * The latitude
     * @var float
     */
    public $latitude;
    /**
     * The longitude
     * @var float
     */
    public $longitude;
    /**
     * The citymatch
     * @var string
     */
    public $citymatch;
    /**
     * The streetmatch
     * @var string
     */
    public $streetmatch;
    /**
     * Constructor method for LatLonCoordinatesMatch
     * @uses LatLonCoordinatesMatch::setLatitude()
     * @uses LatLonCoordinatesMatch::setLongitude()
     * @uses LatLonCoordinatesMatch::setCitymatch()
     * @uses LatLonCoordinatesMatch::setStreetmatch()
     * @param float $latitude
     * @param float $longitude
     * @param string $citymatch
     * @param string $streetmatch
     */
    public function __construct($latitude = null, $longitude = null, $citymatch = null, $streetmatch = null)
    {
        $this
            ->setLatitude($latitude)
            ->setLongitude($longitude)
            ->setCitymatch($citymatch)
            ->setStreetmatch($streetmatch);
    }
    /**
     * Get latitude value
     * @return float|null
     */
    public function getLatitude()
    {
        return $this->latitude;
    }
    /**
     * Set latitude value
     * @param float $latitude
     * @return \StructType\LatLonCoordinatesMatch
     */
    public function setLatitude($latitude = null)
    {
        // validation for constraint: float
        if (!is_null($latitude) && !(is_float($latitude) || is_numeric($latitude))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($latitude, true), gettype($latitude)), __LINE__);
        }
        $this->latitude = $latitude;
        return $this;
    }
    /**
     * Get longitude value
     * @return float|null
     */
    public function getLongitude()
    {
        return $this->longitude;
    }
    /**
     * Set longitude value
     * @param float $longitude
     * @return \StructType\LatLonCoordinatesMatch
     */
    public function setLongitude($longitude = null)
    {
        // validation for constraint: float
        if (!is_null($longitude) && !(is_float($longitude) || is_numeric($longitude))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($longitude, true), gettype($longitude)), __LINE__);
        }
        $this->longitude = $longitude;
        return $this;
    }
    /**
     * Get citymatch value
     * @return string|null
     */
    public function getCitymatch()
    {
        return $this->citymatch;
    }
    /**
     * Set citymatch value
     * @param string $citymatch
     * @return \StructType\LatLonCoordinatesMatch
     */
    public function setCitymatch($citymatch = null)
    {
        // validation for constraint: string
        if (!is_null($citymatch) && !is_string($citymatch)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($citymatch, true), gettype($citymatch)), __LINE__);
        }
        $this->citymatch = $citymatch;
        return $this;
    }
    /**
     * Get streetmatch value
     * @return string|null
     */
    public function getStreetmatch()
    {
        return $this->streetmatch;
    }
    /**
     * Set streetmatch value
     * @param string $streetmatch
     * @return \StructType\LatLonCoordinatesMatch
     */
    public function setStreetmatch($streetmatch = null)
    {
        // validation for constraint: string
        if (!is_null($streetmatch) && !is_string($streetmatch)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($streetmatch, true), gettype($streetmatch)), __LINE__);
        }
        $this->streetmatch = $streetmatch;
        return $this;
    }
}
