<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for NeighborhoodPagedResult StructType
 * @subpackage Structs
 */
class NeighborhoodPagedResult extends AbstractStructBase
{
    /**
     * The paging
     * @var \StructType\ResultInfo
     */
    public $paging;
    /**
     * The results
     * @var \ArrayType\NeighborhoodArray
     */
    public $results;
    /**
     * Constructor method for NeighborhoodPagedResult
     * @uses NeighborhoodPagedResult::setPaging()
     * @uses NeighborhoodPagedResult::setResults()
     * @param \StructType\ResultInfo $paging
     * @param \ArrayType\NeighborhoodArray $results
     */
    public function __construct(\StructType\ResultInfo $paging = null, \ArrayType\NeighborhoodArray $results = null)
    {
        $this
            ->setPaging($paging)
            ->setResults($results);
    }
    /**
     * Get paging value
     * @return \StructType\ResultInfo|null
     */
    public function getPaging()
    {
        return $this->paging;
    }
    /**
     * Set paging value
     * @param \StructType\ResultInfo $paging
     * @return \StructType\NeighborhoodPagedResult
     */
    public function setPaging(\StructType\ResultInfo $paging = null)
    {
        $this->paging = $paging;
        return $this;
    }
    /**
     * Get results value
     * @return \ArrayType\NeighborhoodArray|null
     */
    public function getResults()
    {
        return $this->results;
    }
    /**
     * Set results value
     * @param \ArrayType\NeighborhoodArray $results
     * @return \StructType\NeighborhoodPagedResult
     */
    public function setResults(\ArrayType\NeighborhoodArray $results = null)
    {
        $this->results = $results;
        return $this;
    }
}
