<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for RangeAddress StructType
 * @subpackage Structs
 */
class RangeAddress extends AbstractStructBase
{
    /**
     * The reeks
     * @var \StructType\PCReeks
     */
    public $reeks;
    /**
     * The huisnr
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $huisnr;
    /**
     * The huisnr_toevoeging
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $huisnr_toevoeging;
    /**
     * Constructor method for RangeAddress
     * @uses RangeAddress::setReeks()
     * @uses RangeAddress::setHuisnr()
     * @uses RangeAddress::setHuisnr_toevoeging()
     * @param \StructType\PCReeks $reeks
     * @param int $huisnr
     * @param string $huisnr_toevoeging
     */
    public function __construct(\StructType\PCReeks $reeks = null, $huisnr = null, $huisnr_toevoeging = null)
    {
        $this
            ->setReeks($reeks)
            ->setHuisnr($huisnr)
            ->setHuisnr_toevoeging($huisnr_toevoeging);
    }
    /**
     * Get reeks value
     * @return \StructType\PCReeks|null
     */
    public function getReeks()
    {
        return $this->reeks;
    }
    /**
     * Set reeks value
     * @param \StructType\PCReeks $reeks
     * @return \StructType\RangeAddress
     */
    public function setReeks(\StructType\PCReeks $reeks = null)
    {
        $this->reeks = $reeks;
        return $this;
    }
    /**
     * Get huisnr value
     * @return int|null
     */
    public function getHuisnr()
    {
        return $this->huisnr;
    }
    /**
     * Set huisnr value
     * @param int $huisnr
     * @return \StructType\RangeAddress
     */
    public function setHuisnr($huisnr = null)
    {
        // validation for constraint: int
        if (!is_null($huisnr) && !(is_int($huisnr) || ctype_digit($huisnr))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($huisnr, true), gettype($huisnr)), __LINE__);
        }
        $this->huisnr = $huisnr;
        return $this;
    }
    /**
     * Get huisnr_toevoeging value
     * @return string|null
     */
    public function getHuisnr_toevoeging()
    {
        return $this->huisnr_toevoeging;
    }
    /**
     * Set huisnr_toevoeging value
     * @param string $huisnr_toevoeging
     * @return \StructType\RangeAddress
     */
    public function setHuisnr_toevoeging($huisnr_toevoeging = null)
    {
        // validation for constraint: string
        if (!is_null($huisnr_toevoeging) && !is_string($huisnr_toevoeging)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($huisnr_toevoeging, true), gettype($huisnr_toevoeging)), __LINE__);
        }
        $this->huisnr_toevoeging = $huisnr_toevoeging;
        return $this;
    }
}
