<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for RiskLegalRestraintDecision StructType
 * @subpackage Structs
 */
class RiskLegalRestraintDecision extends AbstractStructBase
{
    /**
     * The number
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $number;
    /**
     * The cause
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $cause;
    /**
     * The date
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $date;
    /**
     * The court
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $court;
    /**
     * The jurisdiction
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $jurisdiction;
    /**
     * The district
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $district;
    /**
     * The administrator
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\RiskLegalRestraintAdministrator
     */
    public $administrator;
    /**
     * Constructor method for RiskLegalRestraintDecision
     * @uses RiskLegalRestraintDecision::setNumber()
     * @uses RiskLegalRestraintDecision::setCause()
     * @uses RiskLegalRestraintDecision::setDate()
     * @uses RiskLegalRestraintDecision::setCourt()
     * @uses RiskLegalRestraintDecision::setJurisdiction()
     * @uses RiskLegalRestraintDecision::setDistrict()
     * @uses RiskLegalRestraintDecision::setAdministrator()
     * @param string $number
     * @param string $cause
     * @param string $date
     * @param string $court
     * @param string $jurisdiction
     * @param string $district
     * @param \StructType\RiskLegalRestraintAdministrator $administrator
     */
    public function __construct($number = null, $cause = null, $date = null, $court = null, $jurisdiction = null, $district = null, \StructType\RiskLegalRestraintAdministrator $administrator = null)
    {
        $this
            ->setNumber($number)
            ->setCause($cause)
            ->setDate($date)
            ->setCourt($court)
            ->setJurisdiction($jurisdiction)
            ->setDistrict($district)
            ->setAdministrator($administrator);
    }
    /**
     * Get number value
     * @return string|null
     */
    public function getNumber()
    {
        return $this->number;
    }
    /**
     * Set number value
     * @param string $number
     * @return \StructType\RiskLegalRestraintDecision
     */
    public function setNumber($number = null)
    {
        // validation for constraint: string
        if (!is_null($number) && !is_string($number)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($number, true), gettype($number)), __LINE__);
        }
        $this->number = $number;
        return $this;
    }
    /**
     * Get cause value
     * @return string|null
     */
    public function getCause()
    {
        return $this->cause;
    }
    /**
     * Set cause value
     * @param string $cause
     * @return \StructType\RiskLegalRestraintDecision
     */
    public function setCause($cause = null)
    {
        // validation for constraint: string
        if (!is_null($cause) && !is_string($cause)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($cause, true), gettype($cause)), __LINE__);
        }
        $this->cause = $cause;
        return $this;
    }
    /**
     * Get date value
     * @return string|null
     */
    public function getDate()
    {
        return $this->date;
    }
    /**
     * Set date value
     * @param string $date
     * @return \StructType\RiskLegalRestraintDecision
     */
    public function setDate($date = null)
    {
        // validation for constraint: string
        if (!is_null($date) && !is_string($date)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($date, true), gettype($date)), __LINE__);
        }
        $this->date = $date;
        return $this;
    }
    /**
     * Get court value
     * @return string|null
     */
    public function getCourt()
    {
        return $this->court;
    }
    /**
     * Set court value
     * @param string $court
     * @return \StructType\RiskLegalRestraintDecision
     */
    public function setCourt($court = null)
    {
        // validation for constraint: string
        if (!is_null($court) && !is_string($court)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($court, true), gettype($court)), __LINE__);
        }
        $this->court = $court;
        return $this;
    }
    /**
     * Get jurisdiction value
     * @return string|null
     */
    public function getJurisdiction()
    {
        return $this->jurisdiction;
    }
    /**
     * Set jurisdiction value
     * @param string $jurisdiction
     * @return \StructType\RiskLegalRestraintDecision
     */
    public function setJurisdiction($jurisdiction = null)
    {
        // validation for constraint: string
        if (!is_null($jurisdiction) && !is_string($jurisdiction)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($jurisdiction, true), gettype($jurisdiction)), __LINE__);
        }
        $this->jurisdiction = $jurisdiction;
        return $this;
    }
    /**
     * Get district value
     * @return string|null
     */
    public function getDistrict()
    {
        return $this->district;
    }
    /**
     * Set district value
     * @param string $district
     * @return \StructType\RiskLegalRestraintDecision
     */
    public function setDistrict($district = null)
    {
        // validation for constraint: string
        if (!is_null($district) && !is_string($district)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($district, true), gettype($district)), __LINE__);
        }
        $this->district = $district;
        return $this;
    }
    /**
     * Get administrator value
     * @return \StructType\RiskLegalRestraintAdministrator|null
     */
    public function getAdministrator()
    {
        return $this->administrator;
    }
    /**
     * Set administrator value
     * @param \StructType\RiskLegalRestraintAdministrator $administrator
     * @return \StructType\RiskLegalRestraintDecision
     */
    public function setAdministrator(\StructType\RiskLegalRestraintAdministrator $administrator = null)
    {
        $this->administrator = $administrator;
        return $this;
    }
}
