<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SepaMatchBankAccountHolder StructType
 * @subpackage Structs
 */
class SepaMatchBankAccountHolder extends AbstractStructBase
{
    /**
     * The type
     * @var string
     */
    public $type;
    /**
     * The number_of_account_holders
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $number_of_account_holders;
    /**
     * The joint_account
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $joint_account;
    /**
     * The municipality
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $municipality;
    /**
     * Constructor method for SepaMatchBankAccountHolder
     * @uses SepaMatchBankAccountHolder::setType()
     * @uses SepaMatchBankAccountHolder::setNumber_of_account_holders()
     * @uses SepaMatchBankAccountHolder::setJoint_account()
     * @uses SepaMatchBankAccountHolder::setMunicipality()
     * @param string $type
     * @param int $number_of_account_holders
     * @param bool $joint_account
     * @param string $municipality
     */
    public function __construct($type = null, $number_of_account_holders = null, $joint_account = null, $municipality = null)
    {
        $this
            ->setType($type)
            ->setNumber_of_account_holders($number_of_account_holders)
            ->setJoint_account($joint_account)
            ->setMunicipality($municipality);
    }
    /**
     * Get type value
     * @return string|null
     */
    public function getType()
    {
        return $this->type;
    }
    /**
     * Set type value
     * @param string $type
     * @return \StructType\SepaMatchBankAccountHolder
     */
    public function setType($type = null)
    {
        // validation for constraint: string
        if (!is_null($type) && !is_string($type)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($type, true), gettype($type)), __LINE__);
        }
        $this->type = $type;
        return $this;
    }
    /**
     * Get number_of_account_holders value
     * @return int|null
     */
    public function getNumber_of_account_holders()
    {
        return $this->number_of_account_holders;
    }
    /**
     * Set number_of_account_holders value
     * @param int $number_of_account_holders
     * @return \StructType\SepaMatchBankAccountHolder
     */
    public function setNumber_of_account_holders($number_of_account_holders = null)
    {
        // validation for constraint: int
        if (!is_null($number_of_account_holders) && !(is_int($number_of_account_holders) || ctype_digit($number_of_account_holders))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($number_of_account_holders, true), gettype($number_of_account_holders)), __LINE__);
        }
        $this->number_of_account_holders = $number_of_account_holders;
        return $this;
    }
    /**
     * Get joint_account value
     * @return bool|null
     */
    public function getJoint_account()
    {
        return $this->joint_account;
    }
    /**
     * Set joint_account value
     * @param bool $joint_account
     * @return \StructType\SepaMatchBankAccountHolder
     */
    public function setJoint_account($joint_account = null)
    {
        // validation for constraint: boolean
        if (!is_null($joint_account) && !is_bool($joint_account)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($joint_account, true), gettype($joint_account)), __LINE__);
        }
        $this->joint_account = $joint_account;
        return $this;
    }
    /**
     * Get municipality value
     * @return string|null
     */
    public function getMunicipality()
    {
        return $this->municipality;
    }
    /**
     * Set municipality value
     * @param string $municipality
     * @return \StructType\SepaMatchBankAccountHolder
     */
    public function setMunicipality($municipality = null)
    {
        // validation for constraint: string
        if (!is_null($municipality) && !is_string($municipality)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($municipality, true), gettype($municipality)), __LINE__);
        }
        $this->municipality = $municipality;
        return $this;
    }
}
